'use strict';
        
var cameraChoixController = [
    '$scope',
    '$rootScope',
    '$route',
    '$location',
    'GeneanetDevice',
    'ProjectService',
    'GenerateSqlService',
    'GeneanetDatabase',
    'GeneanetFile',
    "GeneanetImage",
    function($scope, $rootScope, $route, $location, GeneanetDevice, ProjectService, GenerateSqlService, GeneanetDatabase, GeneanetFile, GeneanetImage) {
        document.addEventListener('deviceready', GeneanetDevice.determineOrientationCurrentPage);

        $scope.countPictures = 0;

        var nameEventAfterFinishedTakePicture = "finishedTakePicture";
        $scope.$on(nameEventAfterFinishedTakePicture, function(event, args){
            $location.path("/cameraChoix/").replace();
            $route.reload();
        });

        var currentIdPicture = ProjectService.getCurrentIdPicture();
        var currentIdDepot = ProjectService.getCurrentIdDepot();
        var currentIdProject = ProjectService.getCurrentIdProject();
        // si on a pas d'id de photo, on lance directement l'appareil photo.
        if (!currentIdPicture) {
            ProjectService.takePicture(nameEventAfterFinishedTakePicture);
        } else {
            $scope.currentIdPicture = currentIdPicture;
            
            $scope.seeAllPictures = function() {
                ProjectService.setCurrentIdDepot(null);
                var stopChangeRoute = $rootScope.$on("$locationChangeSuccess", function() {
                    stopChangeRoute();
                    ProjectService.setCurrentIdProject(currentIdProject);
                    $location.path("/galleryProject/true");
                    $route.reload();
                });
                $location.path("/");
                $route.reload();
            }

            $scope.restartTakePicture = function() {
                // Récupérer path physique de l'image
                var reqGetInfosPictures = GenerateSqlService.getPhotosFromIds(currentIdPicture);
                GeneanetDatabase.executeRequest(
                    reqGetInfosPictures,
                    function(tx, results) {
                        if (results.rows.length > 0) {
                            var nativeUrlCurrentPicture = results.rows.item(0).native_url;

                            // delete image BDD
                            var reqDeletePictures = GenerateSqlService.deletePhotosFromIds(currentIdPicture);
                            GeneanetDatabase.executeRequest(
                                reqDeletePictures,
                                function(tx, results) {
                                    ProjectService.setCurrentIdPicture(null);
                                    // delete physique de l'image. Pas besoin d'appeler de callback en cas de succès.
                                    GeneanetFile.deleteFileFromUrl(nativeUrlCurrentPicture);
                                    
                                    // on récupère le nombre de photos encore lié au dépot.
                                    var reqCountNbPhotosFromIdDepot = GenerateSqlService.getNbPhotosFromIdDepot(currentIdDepot);
                                    GeneanetDatabase.executeRequest(
                                        reqCountNbPhotosFromIdDepot,
                                        function(tx, results){
                                            // pas d'autre photo, on supprimer le depot de la BDD
                                            if (results.rows.item(0).nb_photos == 0) {
                                                ProjectService.setCurrentIdDepot(null);

                                                var reqDeleteDepot = GenerateSqlService.deleteDepotsFromIds(currentIdDepot);
                                                GeneanetDatabase.executeRequest(reqDeleteDepot, function() {});
                                            }
                                            $route.reload();
                                        }
                                    );
                                }
                            );
                        } else {
                            ProjectService.setCurrentIdPicture(null);
                            $route.reload();
                        }
                    }
                );
            };

            $scope.nextGrave = function() {
                ProjectService.setCurrentIdDepot(null);
                ProjectService.setCurrentIdPicture(null);
                $route.reload();
            };

            $scope.nextView = function() {
                ProjectService.setCurrentIdPicture(null);
                $route.reload();
            };

            var requestGetInfoProject = GenerateSqlService.getProjectsWithCountPictures(currentIdProject);
            GeneanetDatabase.executeRequest(requestGetInfoProject, function(tx, results) {
                if (results.rows.length > 0) {
                    var infoProject = results.rows.item(0);
                    $scope.$apply(function() {
                        $scope.nameProject = infoProject.nom_projet;
                        $scope.namePlace = infoProject.place;
                        $scope.countPictures = infoProject.count_picture;
                    });
                    if ($scope.countPictures == 1) {
                        angular.element("#picture-project").addClass("cadre1");
                    } else if ($scope.countPictures == 2) {
                        angular.element("#picture-project").addClass("cadre2");
                    } else if ($scope.countPictures > 2) {
                        angular.element("#picture-project").addClass("cadre3");
                    }
                    
                    if ($scope.countPictures >= 1) {
                        var requestFirstPicture = GenerateSqlService.getFirstPictureFromProject(currentIdProject);
                        GeneanetDatabase.executeRequest(requestFirstPicture, function(tx, results) {
                            if (results.rows.length > 0) {
                                var firstPicture = results.rows.item(0);
                                var img = angular.element("#picture-project img")[0];
                                img.src = firstPicture.native_url;
                            }
                        });
                    }

                }
            });
        }
    }
];