'use strict';
        
var configurationController = [
    "$scope",
    "$route",
    "$translate",
    "GeneanetDevice",
    "GeneanetOverlay",
    "GeneanetDatabase",
    "GeneanetFile",
    "GenerateSqlService",
    function($scope, $route, $translate, GeneanetDevice, GeneanetOverlay, GeneanetDatabase, GeneanetFile, GenerateSqlService) {
        document.addEventListener('deviceready', GeneanetDevice.determineOrientationCurrentPage);

        $scope.back = function () {
            window.history.back();
        }

        $scope.$on("overlayDialogResponse", function(event, data) {
            if (data.response) {
                var requestGetPicturesSynchronized = GenerateSqlService.getPicturesSynchronized();
                GeneanetDatabase.executeRequest(requestGetPicturesSynchronized, function(tx, results) {
                    var idsPictures = [];
                    $scope.$on("deleteFileSuccess", function(event, data) {
                        GeneanetOverlay.advance();
                        if (GeneanetOverlay.progressBarIsFinished()) {
                            var requestDeletePictures = GenerateSqlService.deletePhotosFromIds(idsPictures);
                            GeneanetDatabase.executeRequest(requestDeletePictures, function(tx, results) {
                                var requestDeleteEmptyDepot = GenerateSqlService.deleteEmptyDepot();
                                GeneanetDatabase.executeRequest(requestDeleteEmptyDepot, function(tx, results) {
                                    $scope.$on("GeneanetOverlayClose", function() {
                                        $route.reload();
                                    });
                                    GeneanetOverlay.openOverlay(
                                        $translate.instant("alert.delete_pictures_synchronized_done"),
                                        $translate.instant("alert.delete_pictures_synchronized_count")+" "+idsPictures.length
                                    );
                                });
                            });
                        }
                    });
                    if (results.rows.length > 0) {
                        GeneanetOverlay.openProgressBar(
                            $translate.instant("alert.delete_pictures_progress"),
                            0,
                            results.rows.length
                        );
                        for(var i = 0; i < results.rows.length; i++) {
                            idsPictures.push(results.rows.item(i).id_picture);
                            GeneanetFile.deleteFileFromUrl(results.rows.item(i).native_url, "deleteFileSuccess");
                        }
                    }
                });
            }
        });

        $scope.deletePicturesSynchronized = function() {
            GeneanetOverlay.openDialog(
                $translate.instant("alert.delete_pictures_synchronized"),
                $translate.instant("dialog.yes"),
                "btn btn-gnn-primary",
                $translate.instant("dialog.no"),
                "btn btn-gnn-secondary"
            );
        }
    }
]