"use strict";

var detailsProjectController = [
    "$scope",
    "$routeParams",
    "$http",
    "$translate",
    "$timeout",
    "GeneanetDevice",
    "GeneanetOverlay",
    "urlsWebservice",
    function($scope, $routeParams, $http, $translate, $timeout, GeneanetDevice, GeneanetOverlay, urlsWebservice) {
        document.addEventListener("deviceready", GeneanetDevice.determineOrientationCurrentPage);

        $scope.back = function() {
            window.history.back();
        };

        /**
         * Permet d'ouvrir un lien.
         *
         * @param {string} url Url que l'on désire ouvrir.
         */
        $scope.openLink = function(url) {
            window.open(url, "_blank", "location=yes");
        };

        $scope.$on("projectLoaded", function(event, data) {
            var currentProject = data.project;
            // on va extraire en fonction de la langue, la position du projet.
            $http.get("datas/geoRessources.json").success(
                function (data) {
                    var currentGeo = null;
                    var positionProject = [];
                    // parcours les pays pour trouver celui du depot et l"extraire.
                    for (var i = data.length - 1; i >= 0; i--) {
                        if (data[i].symbol == currentProject.country) {
                            currentGeo = data[i];
                            positionProject.unshift(currentGeo["name_"+$translate.preferredLanguage()]);
                            break;
                        }
                    }

                    // parcours des régions pour trouver celle du depot et l"extraire.
                    if (currentGeo !== null && currentGeo.hasOwnProperty("regions")) {
                        for (var j = currentGeo.regions.length - 1; j >= 0; j--) {
                            if (currentGeo.regions[j].symbol == currentProject.region) {
                                positionProject.unshift(currentGeo.regions[j].name);
                                break;
                            }
                        }
                    }

                    $scope.positionProject = positionProject.join(", ");
                }
            );

            // on génère l"url vers geneanet pour ce projet.
            currentProject.urlGeneanet = "https://www.geneanet.org/cimetieres/collection/"+currentProject.id+'-'+currentProject.nom_projet;
            // on assigne le projet à la vue.
            $scope.project = currentProject;

            GeneanetOverlay.close();
        });

        // on récupère les infos sur le projet depuis le cache si présent.
        var projectsGnnCache = JSON.parse(sessionStorage.getItem("projectsGnnCache"));
        var currentProject = null;
        if (projectsGnnCache !== null) {
            var projects = projectsGnnCache.projects;
            for (var i = projects.length - 1; i >= 0; i--) {
                if (projects[i].id == $routeParams.idProject) {
                    currentProject = projects[i];
                    $scope.$broadcast("projectLoaded", {project: currentProject});
                    break;
                }
            }
        }

        // pas dans le cache on va essayer sur l'api.
        if (currentProject === null) {
            GeneanetOverlay.openSpinner($translate.instant("spinner.get_data"));
            $timeout(function() {
                // check connexion
                if (!GeneanetDevice.accessInternetStarted()) {
                    $scope.$on("GeneanetOverlayClose", function() {
                        $scope.back();
                    });
                    GeneanetOverlay.openOverlay(
                        $translate.instant("alert.offline"),
                        $translate.instant("alert.need_connection")
                    );
                } else {
                    $http.get(urlsWebservice.galleryUrl + "projects/show/" + $routeParams.idProject)
                        .success(
                            function (data) {
                                if (data.project !== false) {
                                    $scope.$broadcast("projectLoaded", {project: data.project});
                                } else {
                                    var title = $translate.instant("alert.error");
                                    var content = $translate.instant("alert.details_not_found");
                                    $scope.$on("GeneanetOverlayClose", function() {
                                        $scope.back();
                                    });
                                    GeneanetOverlay.openOverlay(title, content);
                                }
                            }
                        )
                        .error(
                            function() {
                                var title = $translate.instant("alert.error");
                                var content = $translate.instant("alert.fail_connect_gnn_more");
                                $scope.$on("GeneanetOverlayClose", function() {
                                    $scope.back();
                                });
                                GeneanetOverlay.openOverlay(title, content);
                            }
                        );
                }
            }, 0, true);
        }
    }
];
