'use strict';
        
var galleryProjectController = [
    '$scope',
    '$rootScope',
    '$location',
    '$route',
    '$routeParams',
    '$translate',
    '$compile',
    'GenerateSqlService',
    'GeneanetDevice',
    'GeneanetDatabase',
    'GeneanetImage',
    'GeneanetFile',
    'GeneanetOverlay',
    'ProjectService',
    function ($scope, $rootScope, $location, $route, $routeParams, $translate, $compile, GenerateSqlService, GeneanetDevice, GeneanetDatabase, GeneanetImage, GeneanetFile, GeneanetOverlay, ProjectService) {
        // Constante du nom d'évent qui signale la fin du chargement des images.
        var NAME_EVENT_LOAD_IMAGE_FINISH = "load_image_finished";
        // Constante du nom d'évent qui signale qu'on démarre une action delete.
        var NAME_EVENT_ACTION_DELETE = "action_delete";
        // permet de stocker le template des block d'image pour eviter de le regénérer à chaque fois.
        var templatePicture = null;
        // Permet de savoir d'où démarrer le limit SQL pour la récupération des depots.
        var startLimit = 0;
        // Constante permettant de limiter la récupération d'images par lot de 18.
        var MAX_LIMIT = 18;
        // permet de préciser si le projet est vide
        $scope.projectEmpty = null;
        // permet d'indiquer au template qu'on est en train de load ou non des images.
        $scope.loadPicturesFinished = false;

        var projectPrivate = false;

        document.addEventListener('deviceready', GeneanetDevice.determineOrientationCurrentPage);

        $scope.$on("stopActionsToResize", function() {
            angular.element("#content-gallery li").each(function() {
                angular.element(this).remove();
                if (angular.element("#content-gallery li").length <= 0) {
                    angular.element(".content-cell").scrollTop(0);
                    prevHeight = 0;
                    startLimit = 0;
                    
                    $scope.cancelActionToDeleteDepot();
                    listerDepotGalerie();

                    $scope.$apply(function() {
                        $scope.stopScrollInfinite = false;
                    });
                }
            });
        });

        $scope.$on(
            "resize",
            function() {
                managerActions.stopAllActions("stopActionsToResize");
            }
        );

        // affiche les blocs lorsque les données pour le faire ont été chargées.
        $scope.$on(NAME_EVENT_LOAD_IMAGE_FINISH, function(event, data){
            // si on a récupérer moins d'image que la taille du limit, on stoppe le calcul du scroll infini.
            if (data.listDepots.length < MAX_LIMIT) {
                $scope.stopScrollInfinite = true;
            }

            $scope.$apply(function() {
                // première fois, on va setter le premier lot de dépot.
                if ($scope.projectEmpty == null) {
                    $scope.projectEmpty = data.listDepots.length <= 0 ? true : false;
                }
                // on a fini de générer les blocs.
                $scope.generateLisFinished = true;
            });

            // on parcourt les images une à une et on les ajoute à la page.
            for (var i in data.listDepots) {
                if (managerActions.getStatus("generateLis")) {
                    addLiPicture(data.listDepots[i]);
                } else {
                    managerActions.eventStopped("generateLis");
                    break;
                }
            }
            
            if (managerActions.getStatus("generateLis")) {
                managerActions.active("assignPictures");
                // on signale qu'on a fini de générer les éléments pour stocker les photos
                $scope.$broadcast("assign_list_picture_finished", {listDepots: data.listDepots, start:0});
            }
            managerActions.inactive("generateLis");
        });

        // on va procéder au redimensionnement des images.
        $scope.$on("assign_list_picture_finished", function(event, data){
            if (data.start < data.listDepots.length) {
                var currentDepot = data.listDepots[data.start];
                var img = angular.element("#depot-"+currentDepot.id_depot)[0];
                
                if (typeof img == "undefined") {
                    return;
                }

                var screenOrientationPortrait = window.matchMedia("(orientation: portrait)").matches;
                var base64Picture;

                if (screenOrientationPortrait) {
                    base64Picture = currentDepot.base64_portrait;
                } else {
                    base64Picture = currentDepot.base64_landscape;
                }

                var loadPicture = function() {
                    if (!base64Picture) {
                        if (managerActions.getStatus("assignPictures")) {
                            var newWidth = angular.element(".content-picture").width();
                            var newHeight = angular.element(".content-picture").height();
                            base64Picture = GeneanetImage.resize(img, newWidth, newHeight, "image/jpg");
                            
                            var requestUpdateBase64;
                            if (screenOrientationPortrait) {
                                requestUpdateBase64 = GenerateSqlService.updateDepotBase64Portrait(currentDepot.id_depot, base64Picture);
                            } else {
                                requestUpdateBase64 = GenerateSqlService.updateDepotBase64Landscape(currentDepot.id_depot, base64Picture);
                            }
                            GeneanetDatabase.executeRequest(requestUpdateBase64, function(){});
                            img.src = base64Picture;
                        } else {
                            managerActions.eventStopped("assignPictures");
                            return;
                        }
                    }
                    $scope.$broadcast("assign_list_picture_finished", {listDepots: data.listDepots, start: data.start+1});
                };

                img.onerror = function() {
                    base64Picture = false;
                    img.onerror = null;
                    img.src = currentDepot.native_url;
                }

                img.onload = loadPicture;

                if(managerActions.getStatus("assignPictures")) {
                    if (!base64Picture) {
                        img.src = currentDepot.native_url;
                    } else {
                        img.src = base64Picture;
                    }
                }else {
                    managerActions.eventStopped("assignPictures");
                }
            } else {
                managerActions.inactive("assignPictures");
            }
        });

        // Permet de formater/filtrer la liste des depots issues de la BDD.
        var listerDepotGalerie = function () {
            $scope.generateLisFinished = false;

            var depotSuccess = function (tx, result) {
                startLimit = startLimit + MAX_LIMIT;
                var tab = new Array();

                for (var i = 0; i < result.rows.length; i++ ){
                    var currentDepot = result.rows.item(i);
                    if (currentDepot.nb_image == 1) {
                        currentDepot.classCss = "cadre1";
                    } else if (currentDepot.nb_image == 2) {
                        currentDepot.classCss = "cadre2";
                    } else if (currentDepot.nb_image > 2) {
                        currentDepot.classCss = "cadre3";
                    } else {
                        continue;
                    }

                    tab.push(currentDepot);
                }

                managerActions.active("generateLis");
                $scope.$broadcast(NAME_EVENT_LOAD_IMAGE_FINISH, {listDepots: tab})
            }

            var inverseOrderBy = $routeParams.inverseOrderBy == "true" ? true : false;
            var requestGetInfosDepots = GenerateSqlService.getInfoDepotsFromProject(ProjectService.getCurrentIdProject(), startLimit, MAX_LIMIT, inverseOrderBy);
            GeneanetDatabase.executeRequest(requestGetInfosDepots, depotSuccess);
        }

        var selected = function(depot) {
            managerActions.stopAllActions();
            ProjectService.setCurrentIdDepot(depot.id_depot);
            $location.path('/pictureReader/');
        }

        var addLiPicture = function(depot) {
            if (templatePicture == null) {
                var li = angular.element("<li>");
                var label = angular.element("<label>");
                var input = angular.element("<input>");
                var link = angular.element("<a>");
                var spanPicture = angular.element("<span>");
                var img = angular.element("<img>");

                input.addClass("checkbox-gallery")
                    .attr("type", "checkbox")
                    .attr("name", "selectedDepot[]")
                    .val("{{ depot.id_depot }}");

                label.addClass("label-gallery")
                    .attr("ng-if", "launchSup");
                label.append(input);
                li.append(label);

                img.attr("id", "depot-{{depot.id_depot}}")
                    .attr("src", "img/spinner/spinner-black.gif");

                spanPicture.addClass("content-picture");
                spanPicture.append(img);
                link.append(spanPicture);
                
                var spanCountPictures = angular.element("<span>");
                spanCountPictures.addClass("notif-nb-img fs-big")
                    .attr("ng-if", "depot.nb_image > 1")
                    .html("{{ depot.nb_image }}");
                link.append(spanCountPictures);

                link.attr("ng-click", "selected(depot)");
                link.attr("class", "{{ depot.classCss }}");

                li.append(link);

                templatePicture = $compile(li);
            }

            var scopeDepot = $rootScope.$new();
            scopeDepot.depot = depot;
            scopeDepot.selected = selected;
            scopeDepot.$on(NAME_EVENT_ACTION_DELETE, function(event, data){
                scopeDepot.launchSup = data.start;
            });

            $scope.$apply(function() {
                templatePicture(scopeDepot, function(cloneElement, scope) {
                    angular.element("#content-gallery").append(cloneElement);
                });
            });
        }

        $scope.startActionToDeleteDepot = function() {
            $scope.lanchSup = true;
            $rootScope.$broadcast(NAME_EVENT_ACTION_DELETE, {start: true});
        }

        $scope.cancelActionToDeleteDepot = function() {
            $scope.lanchSup = false;
            $rootScope.$broadcast(NAME_EVENT_ACTION_DELETE, {start: false});
        }

        $scope.suppressionDepot = function () {
            var listIdDepotsDelete = new Array();
            angular.element("#content-gallery :checked").each(function(){
                listIdDepotsDelete.push(this.value);
            });

            if (listIdDepotsDelete.length == 0) {
                $scope.cancelActionToDeleteDepot();

                return;
            }

            var successGetInfoPictures = function(tx, result) {
                var listPicturesDelete = new Array();
                var listIdPicturesDelete = new Array();

                for (var i = 0; i < result.rows.length; i++) {
                    var currentPictureDelete = result.rows.item(i);
                    listPicturesDelete.push(currentPictureDelete);
                    listIdPicturesDelete.push(currentPictureDelete.id_picture);
                }

                var requestDeletePictures = GenerateSqlService.deletePhotosFromIds(listIdPicturesDelete);
                GeneanetDatabase.executeRequest(requestDeletePictures, function(){console.debug("suppression des images en bdd");});
                var requestDeleteDepots = GenerateSqlService.deleteDepotsFromIds(listIdDepotsDelete);
                GeneanetDatabase.executeRequest(requestDeleteDepots, function(){console.debug("suppression des depots en bdd");});

                var totalPictures = listPicturesDelete.length;
                var descriptionOverlay = $translate.instant("progress_bar.delete_picture");
                GeneanetOverlay.openProgressBar(descriptionOverlay, 0, totalPictures);

                var countPicturesDeleted = 0;


                var deletePictureNext = function(event, data) {
                    GeneanetOverlay.advance();

                    if (GeneanetOverlay.progressBarIsFinished()) {
                        $scope.$broadcast("deletePictureEnd", []);
                    }
                }

                // réussite
                $scope.$on("deletePictureSuccess", deletePictureNext);

                // impossible d'accéder au fichier
                $scope.$on("getFileFromUrlFailed", deletePictureNext);

                // suppression terminée
                $scope.$on("deletePictureEnd", function(event, data){
                    GeneanetOverlay.close();
                    $route.reload();
                });

                for (var i in listPicturesDelete) {
                    GeneanetFile.deleteFileFromUrl(listPicturesDelete[i].native_url, "deletePictureSuccess");
                }
            }

            var requestInfosPictures = GenerateSqlService.getInfosPicturesFromIdDepots(listIdDepotsDelete);
            GeneanetDatabase.executeRequest(requestInfosPictures, successGetInfoPictures);
        }

        $scope.takePicture = function () {
            managerActions.stopAllActions();

            ProjectService.setCurrentIdDepot(null);
            ProjectService.setCurrentIdPicture(null);

            $location.path('/cameraChoix/');
        }

        $scope.back = function () {
            managerActions.stopAllActions();
            window.history.back();
        }

        // Permet de récupérer le nom du projet courrant et de le setter au template.
        var successGetInfoProject = function(tx, result) {
            if (result.rows.length > 0) {
                $scope.$apply(function() {
                    var projectFound = result.rows.item(0);
                    $scope.nameProject = projectFound.nom_projet;
                    if (
                        (projectFound.proprietaire != null && projectFound.proprietaire.trim().length > 0) ||
                        (projectFound.id_projet_gnn == null)
                    ) {
                        projectPrivate = true;
                    } else {
                        projectPrivate = false;
                    }
                });
            } else {
                console.error("Can't get data on project : " + ProjectService.getCurrentIdProject())
            }
        }

        var managerActions = new function() {
            var actions = {
                "generateLis": {
                    status: false,
                    eventStopped: "generateLisStopped",
                    thread: 0
                },
                "assignPictures": {
                    status: false,
                    eventStopped: "assignPicturesStopped",
                    thread: 0
                }
            };

            this.getInfosActions = function(){
                return actions;
            }

            this.active = function(name) {
                actions[name].status = true;
                actions[name].thread++;
            }

            this.inactive = function(name) {
                actions[name].thread--;
                if (actions[name].thread <= 0) {
                    actions[name].thread = 0;
                    actions[name].status = false;
                }
            }

            this.getStatus = function(name) {
                return actions[name].status;
            }

            this.getThread = function(name) {
                return actions[name].thread;
            }

            this.eventStopped = function(name) {
                actions[name].thread--;
                if (actions[name].thread <= 0) {
                    actions[name].thread = 0;
                    $rootScope.$broadcast(actions[name].eventStopped, {});
                }
            }

            this.stopAllActions = function(nameEvent) {
                var checkFinished = function() {
                    var allFinished = true;
                    for (var name in actions) {
                        if (managerActions.getThread(name) != 0) {
                            allFinished = false;
                            break;
                        }
                    }
                    if (allFinished) {
                        if (nameEvent != undefined) {
                            $rootScope.$broadcast(nameEvent, {});
                        }

                        return true;
                    } else {
                        return false;
                    }
                }
                if (!checkFinished()) {
                    var scopeStopActions = $rootScope.$new();
                    for (var name in actions) {
                        scopeStopActions.$on(actions[name].eventStopped, function(){
                            checkFinished();
                        });
                        actions[name].status = false;
                    }
                }
            }
        }

        var requestGetInfoProject = GenerateSqlService.getProjectsFromIds(ProjectService.getCurrentIdProject());
        GeneanetDatabase.executeRequest(requestGetInfoProject, successGetInfoProject);

        var prevHeight = 0;
        $scope.stopScrollInfinite = false;
        $scope.childScrollInfinite = angular.element("#content-gallery");
        $scope.distanceScrollInfinite = function() {
            return angular.element("#content-gallery").children(":first-child").height() * 2;
        }
        $scope.functScrollInfinite = function() {
            if (angular.element("#content-gallery").height() > prevHeight) {
                prevHeight = angular.element("#content-gallery").height();
                $scope.cancelActionToDeleteDepot();
                listerDepotGalerie();
            }
        }

        // overlay de confirm pour delete un projet.
        var confirmDeleteProject = function(idProject) {
            $scope.$on("overlayDialogResponse", function(event, data) {
                if (data.response) {
                    deleteProject(idProject);
                } else {
                    $route.reload();
                }
            });
            GeneanetOverlay.openDialog(
                $translate.instant("gallery.delete_query"),
                $translate.instant("dialog.yes"),
                "btn btn-gnn-primary",
                $translate.instant("dialog.no"),
                "btn btn-gnn-secondary"
            );
        }

        // fonction de delete d'un projet depuis son id.
        var deleteProject = function(idProject) {
            var listIdsPictures = new Array();
            var listIdsDepots = new Array();

            // action en fin de suppression des photos.
            $scope.$on("deletePictureToDeleteProjectFinish", function(event, data) {
                var requestDeletePictures = GenerateSqlService.deletePhotosFromIds(listIdsPictures);
                GeneanetDatabase.executeRequest(requestDeletePictures, function(tx, results) {
                    var requestDeleteDepots = GenerateSqlService.deleteDepotsFromIds(listIdsDepots);
                    GeneanetDatabase.executeRequest(requestDeleteDepots, function(tx, results) {
                        var requestDeleteProjects = GenerateSqlService.deleteProjectsFromIds(idProject);
                        GeneanetDatabase.executeRequest(requestDeleteProjects, function(tx, results) {
                            $scope.back();
                        });
                    });
                });
            });

            // action a chaque delete d'une photo
            var progressBarDeleteProject = function(event, data) {
                GeneanetOverlay.advance();
                if (GeneanetOverlay.progressBarIsFinished()) {
                    $scope.$broadcast("deletePictureToDeleteProjectFinish", {});
                }
            }
            $scope.$on("getFileFromUrlFailed", progressBarDeleteProject);
            $scope.$on("deletePictureToDeleteProject", progressBarDeleteProject);

            // on lance la suppression.
            var requestInfosProject = GenerateSqlService.getInfosProjectToDelete(idProject);
            GeneanetDatabase.executeRequest(requestInfosProject, function(tx, results) {
                if (results.rows.length > 0) {
                    GeneanetOverlay.openProgressBar($translate.instant("gallery.delete_project_progress"), 0, results.rows.length);
                    for (var i = 0; i < results.rows.length; i++) {
                        var result = results.rows.item(i);
                        listIdsPictures.push(result.id_picture);
                        listIdsDepots.push(result.id_depot);
                        GeneanetFile.deleteFileFromUrl(result.native_url, "deletePictureToDeleteProject");
                    }
                } else {
                    $scope.$broadcast("deletePictureToDeleteProjectFinish", {});
                }
            });
        }

        $scope.openSettings = function() {
            var descriptionOverlaySettings = angular.element("<div>");
            if (projectPrivate) {
                descriptionOverlaySettings.append(
                    angular
                        .element("<a>")
                        .attr("href", "#/createProject/")
                        .text($translate.instant("create_projectpage.edit_project"))
                        .addClass("btn btn-gnn-secondary")
                        .css("width", "100%")
                        .css("margin-bottom", "1.5rem")
                );
            }
            descriptionOverlaySettings.append(
                angular
                    .element("<a>")
                    .addClass("btn btn-gnn-secondary")
                    .text($translate.instant("gallery.delete_project"))
                    .css("width", "100%")
                    .click(function(event) {
                        event.preventDefault();
                        confirmDeleteProject(ProjectService.getCurrentIdProject())
                    })
                );

            var addButtonDetails = function(tx, result) {
                if (result.rows.length > 0) {
                    var projectFound = result.rows.item(0);
                    if (projectFound.id_projet_gnn !== null) {
                        descriptionOverlaySettings.append(
                            angular
                                .element("<a>")
                                .attr("href", "#/detailsProject/"+projectFound.id_projet_gnn)
                                .text($translate.instant("details.title"))
                                .addClass("btn btn-gnn-secondary")
                                .css("width", "100%")
                                .css("margin-top", "1.5rem")
                        );
                    }
                }
                GeneanetOverlay.openOverlay(" ", descriptionOverlaySettings);
            }

            var requestGetInfoProject = GenerateSqlService.getProjectsFromIds(ProjectService.getCurrentIdProject());
            GeneanetDatabase.executeRequest(requestGetInfoProject, addButtonDetails);
        }

        listerDepotGalerie();
    }
]