'use strict';

var listProjectExistController = [ 
    '$scope',
    '$translate',
    '$location',
    '$routeParams',
    'GeneanetDevice',
    'GeneanetDatabase',
    'GeneanetOverlay',
    'GenerateSqlService',
    'ProjectService',
    function ($scope, $translate, $location, $routeParams, GeneanetDevice, GeneanetDatabase, GeneanetOverlay, GenerateSqlService, ProjectService) {
        var PAGE_GALLERY = "gallery";
        var PAGE_TAKE_PICTURE = "take_picture";

        var currentPageType = $routeParams.pageType;

        document.addEventListener('deviceready', GeneanetDevice.determineOrientationCurrentPage);


        var nameEventLoadProjectFinished = "loadProjectFinished";
        $scope.$on(
            nameEventLoadProjectFinished,
            function(event, args){
                $scope.$apply(function() {
                    $scope.listProjet = args.listProjetExistant;
                });
            }
        );

        var getNbImage = function(tab) {
            var successCount = function (tx, result) {
                for (var i = 0; i < result.rows.length; i++) {
                    for (var j = 0; j < tab.length; j++){
                        if (result.rows.item(i).id_projet_local == tab[j].id_projet_local){
                            var i18nIdPicture;
                            if (result.rows.item(i).nb_image <= 1) {
                                i18nIdPicture = 'list_projectpage.picture';
                            } else {
                                i18nIdPicture = 'list_projectpage.pictures';
                            }
                            tab[j].nb_image = result.rows.item(i).nb_image + ' ' + $translate.instant(i18nIdPicture);
                        }
                    }
                }
                $scope.$broadcast(nameEventLoadProjectFinished, {listProjetExistant: tab});
            }
            
            var requestCountPhoto = GenerateSqlService.countPicturesFromAllProjects();
            GeneanetDatabase.executeRequest(requestCountPhoto, successCount);
        }

        var listerProjectExistant = function () {
            var fnSelectProject = function (tx, result) {
                if (result.rows.length > 0) {
                    var listProjetExistant = new Array();
                    for (var i = 0; i < result.rows.length; i++) {
                        listProjetExistant.push(result.rows.item(i));
                    }
                    getNbImage(listProjetExistant);
                } else {
                    var title = $translate.instant('alert.important');
                    var content = "<p>"+$translate.instant('alert.error_project_exist')+"</p>";
                    content += "<div class='text-center'><a class='btn btn-gnn-primary' href='#/listProjectGnn'>";
                    content += $translate.instant('list_projectpage.text_subButtonCreate')+"</a></div>";
                    GeneanetOverlay.openOverlay(title, content);
                }
            }

            var requestAllProjects = GenerateSqlService.getAllProjectsOrderByLastCreate();
            GeneanetDatabase.executeRequest(requestAllProjects, fnSelectProject);
        }

        var afficherProjetExistant = function () {
            //Afficher la liste
            listerProjectExistant();
            $scope.template_list = { url: 'templates/list_project.html' };
        }

        var selectedNamePage = function (value) {
            switch (value) {
                case PAGE_TAKE_PICTURE:
                    $scope.namePage = $translate.instant('homepage.take_picture');
                    break;
                case PAGE_GALLERY:
                    $scope.namePage = $translate.instant('homepage.my_pictures');
                    break;
            }
        }

        $scope.selected = function (objet) {
            ProjectService.setCurrentIdProject(objet.id_projet_local);
            ProjectService.setCurrentIdDepot(null);
            ProjectService.setCurrentIdPicture(null);
            switch(currentPageType){
                case PAGE_TAKE_PICTURE:
                    //Prendre une photo
                    $location.path('/cameraChoix/');
                    break;
                case PAGE_GALLERY:
                    //Ouvrir tout les projets
                    $location.path('/galleryProject/');
                    break;
            }
        }

        $scope.back = function (){
            window.history.back();
        }

        selectedNamePage(currentPageType);
        afficherProjetExistant();
    }
];