'use strict';

var listProjectGnnController = [
    '$scope',
    '$http',
    '$translate',
    '$location',
    '$timeout',
    'GenerateSqlService',
    'GeneanetDevice',
    'GeneanetDatabase',
    'GeneanetOverlay',
    'GeneanetGeolocation',
    'urlsWebservice',
    'ProjectService',
    function ($scope, $http, $translate, $location, $timeout, GenerateSqlService, GeneanetDevice, GeneanetDatabase, GeneanetOverlay, GeneanetGeolocation, urlsWebservice, ProjectService) {
        document.addEventListener('deviceready', GeneanetDevice.determineOrientationCurrentPage);

        $scope.retryLocalisation = false;

        var listerProjectGnn = function () {
            var loadProject = function(listProjects) {
                $scope.displayDetails = true;
                $scope.listProjet = listProjects;
                // on ferme l'overlay une fois le apply terminé.
                $timeout(GeneanetOverlay.close, 0, true);

                if (listProjects.length == 0) {
                    $scope.noProjects = true;
                }
            }

            // on va vérifier si on a du cache et qu'il est valide.
            var cacheAvailable = false;
            if (sessionStorage.getItem("projectsGnnCache")) {
                var projectsGnnCache = JSON.parse(sessionStorage.getItem("projectsGnnCache"));
                var timeCache = projectsGnnCache.time ? new Date(projectsGnnCache.time) : null;

                if (
                    timeCache &&
                    new Date(timeCache).setMinutes(timeCache.getMinutes()+5) >= new Date() &&
                    projectsGnnCache.projects
                ) {
                    cacheAvailable = true;
                }
            }

            if (cacheAvailable) {
                loadProject(JSON.parse(sessionStorage.getItem("projectsGnnCache")).projects);
            } else {
                var listenerLocaliseUser = $scope.$on("localiseUser", function (event, data) {
                    // On retire le listener de l'event.
                    listenerLocaliseUser();

                    var paramsHttp = {params: {size: 50}};
                    // Si on n'arrive pas à localiser l'utilisateur
                    if (!data.success) {
                        // On va lui donner une autre chance de se localiser avec un texte+bouton.
                        // Si jamais on y arrive toujours pas, on retire le bouton et donc il ne pourra plus faire l'essai.
                        $scope.retryLocalisation = !$scope.retryLocalisation;
                        // on ferme l'overlay.
                        $timeout(GeneanetOverlay.close, 0, true);

                        return;
                    }

                    // Si on a réussi à localiser, on n'a plus besoin du bouton pour réessayer.
                    $scope.retryLocalisation = false;

                    paramsHttp.params.lat = data.position.coords.latitude;
                    paramsHttp.params.lon = data.position.coords.longitude;
                    paramsHttp.params.range = 20;

                    $http
                        .get(urlsWebservice.galleryUrl + 'projects/public', paramsHttp)
                        .success(
                            function (data) {
                                var projectsGnnCache = {
                                    time: new Date(),
                                    projects: data.projects
                                }
                                sessionStorage.setItem("projectsGnnCache", JSON.stringify(projectsGnnCache));
                                loadProject(data.projects);
                            }
                        )
                        .error(
                            function(data, status, headers, config) {
                                var title = $translate.instant('alert.error');
                                var content = $translate.instant('alert.error_get_projectGnn');
                                GeneanetOverlay.openOverlay(title, content);
                            }
                        );
                });

                GeneanetGeolocation.getCurrentPosition("localiseUser", 60000, 4000, true);
            }
        }

        var afficherProjectGnn = function () {
            //Afficher la liste
            listerProjectGnn();
            $scope.template_list = {
                url: 'templates/list_project.html'
            };
        }


        $scope.selected = function(objet) {
            var fnRequest = function () {
                $scope.back();
            }

            var elementsGeo = new Array();
            if (objet.lat != null && objet.lon != null) {
                elementsGeo.push(objet.lat);
                elementsGeo.push(objet.lon);
            } else {
                if (objet.country != "") {
                    elementsGeo.push(objet.country);
                }
                if (objet.region != "") {
                    elementsGeo.push(objet.region);
                }
                if (objet.subregion != "") {
                    elementsGeo.push(objet.subregion);
                }
            }
            var request = GenerateSqlService.insertionProjet(objet.id, objet.nom_projet, objet.place, objet.type_projet, elementsGeo.join(","), null);
            GeneanetDatabase.executeRequest(request, fnRequest);
        }

        $scope.details = function(project) {
            $location.path("/detailsProject/"+project.id);
        }

        $scope.back = function (){
            window.history.back();
        }

        $scope.createProject = function() {
            ProjectService.setCurrentIdProject(null);
            ProjectService.setCurrentIdDepot(null);
            ProjectService.setCurrentIdPicture(null);

            $location.path('/createProject/');
        }

        $scope.retryLocalisationAction = function() {
            GeneanetOverlay.openSpinner($translate.instant('spinner.get_data'));
            listerProjectGnn();
        };

        GeneanetOverlay.openSpinner($translate.instant('spinner.get_data'));
        // on decale le chargement des projets d'une seconde après la fin de l'$apply pour que la vue s'affiche avec le spinner avant de "freeze".
        $timeout(afficherProjectGnn, 1000, true);
    }
];