'use strict';
        
var pictureReaderController = [
    "$route",
    "$location",
    "$scope",
    "$rootScope",
    "$routeParams",
    "GeneanetDevice",
    "GeneanetDatabase",
    "GeneanetFile",
    "ProjectService",
    "GenerateSqlService",
    function($route, $location, $scope, $rootScope, $routeParams, GeneanetDevice, GeneanetDatabase, GeneanetFile, ProjectService, GenerateSqlService) {
        document.addEventListener('deviceready', GeneanetDevice.determineOrientationCurrentPage);

        var CURRENT_ACTION_DELETE_PICTURE = "delete_picture";
        var CURRENT_ACTION_UNLINK_PICTURE = "unlink_picture";
        var NAME_EVENT_ACTION_FINISHED = "actionFinished";

        var pictures = new Array();
        var currentAction = null;

        $scope.currentPositionPicture = 1;
        $scope.totalPictures = 1;
        $scope.nativeUrlCurrentPicture = "";
        $scope.minimalFooter = false;

        var idPictureStart = $routeParams.idPicture;
        if (idPictureStart) {
            $scope.minimalFooter = true;
        }

        var readTotalProject = $routeParams.readTotalProject === "true" ? true : false;
        
        if (ProjectService.getCurrentIdDepot() == null) {
            window.history.back();
        }

        $scope.startActionToDeletePicture = function() {
            $scope.confirmAction = true;
            currentAction = CURRENT_ACTION_DELETE_PICTURE;
        }

        $scope.startActionToUnlinkPicture = function() {
            $scope.confirmAction = true;
            currentAction = CURRENT_ACTION_UNLINK_PICTURE;
        }

        $scope.cancelAction = function() {
            $scope.confirmAction = false;
        }

        $scope.takePicture = function () {
            ProjectService.setCurrentIdPicture(null);
            $location.path('/cameraChoix/');
        }

        $scope.executeAction = function() {
            $scope.$on(NAME_EVENT_ACTION_FINISHED, function() {
                var requestResetBase64 = GenerateSqlService.resetBase64(ProjectService.getCurrentIdDepot());
                GeneanetDatabase.executeRequest(requestResetBase64);

                if (!$scope.minimalFooter) {
                    $route.reload();
                } else {
                    var currentIdProject = ProjectService.getCurrentIdProject();
                    var stopChangeRoute = $rootScope.$on("$locationChangeSuccess", function() {
                        stopChangeRoute();
                        ProjectService.setCurrentIdProject(currentIdProject);
                        $location.path("/galleryProject/true");
                        $route.reload();
                    });
                    $location.path("/");
                    $route.reload();
                }
            });

            var idPicture = pictures[$scope.currentPositionPicture-1].id_picture;

            if (currentAction == CURRENT_ACTION_DELETE_PICTURE) {
                var fctDeleteFileReturn = function(event, data) {
                    if (!data.success) {
                        console.debug("Erreur de suppression d'image.");
                    }

                    GeneanetDatabase.executeRequest(GenerateSqlService.deleteEmptyDepot(), function(tx, result) {
                        $scope.$broadcast(NAME_EVENT_ACTION_FINISHED, {});
                    });
                }

                $scope.$on("getFileFromUrlFailed", fctDeleteFileReturn);
                $scope.$on("deleteFileSuccess", fctDeleteFileReturn);

                var requestDeletePicture = GenerateSqlService.deletePhotosFromIds(idPicture);
                GeneanetDatabase.executeRequest(requestDeletePicture, function(tx, result){
                    GeneanetFile.deleteFileFromUrl(pictures[$scope.currentPositionPicture-1].native_url, "deleteFileSuccess");
                });
            } else if (currentAction == CURRENT_ACTION_UNLINK_PICTURE) {
                var requestInsertDepot = GenerateSqlService.insertionDepot(ProjectService.getCurrentIdProject(), null);
                GeneanetDatabase.executeRequest(requestInsertDepot, function(tx, results){
                    var newIdDepot = results.insertId;
                    var requestUpdatePicture = GenerateSqlService.updateDepotPictures(idPicture, newIdDepot);
                    GeneanetDatabase.executeRequest(requestUpdatePicture, function(tx, result){
                        $scope.$broadcast(NAME_EVENT_ACTION_FINISHED, {});
                    });
                });
            }
        }

        $scope.back = function () {
            window.history.back();
        }

        // Permet de récupérer le total de photos du depot et de le setter au template.
        var successGetInfoPictures = function(tx, result) {
            if (result.rows.length > 0) {
                for (var i = 0; i < result.rows.length; i++) {
                    if (result.rows.item(i).id_picture == idPictureStart) {
                        $scope.currentPositionPicture = i+1;
                    }
                    pictures.push(result.rows.item(i));
                }

                $scope.$apply(function() {
                    $scope.totalPictures = result.rows.length;
                    $scope.pictures = pictures;
                });
            } else {
                var requestDeleteDepot = GenerateSqlService.deleteDepotsFromIds(ProjectService.getCurrentIdDepot());
                GeneanetDatabase.executeRequest(requestDeleteDepot, function(tx, result){window.history.back()});
            }
        }

        if (readTotalProject) {
            var requestGetInfoPictures = GenerateSqlService.getPicturesFromProject(ProjectService.getCurrentIdProject());
        } else {
            var requestGetInfoPictures = GenerateSqlService.getInfosPicturesFromIdDepots(ProjectService.getCurrentIdDepot());
        }

        GeneanetDatabase.executeRequest(requestGetInfoPictures, successGetInfoPictures);

        $scope.$on("pictureReaderLoadFinish", function() {
            angular.element("#slider-picture").css("width", window.innerWidth+"px");
            window.pictureReaderSwipe = Swipe(document.getElementById("slider-picture"), {
                startSlide: $scope.currentPositionPicture-1,
                callback: function(index, elem) {
                    $scope.$apply(function() {
                        $scope.currentPositionPicture = index+1;
                    });
                }
            });
            angular.element("#slider-picture img").each(function(e) {
                new window.RTP.PinchZoom(this);
                angular.element(this).parent().css("margin-top", (angular.element(".content-cell").height() - angular.element(this).height()) / 2);
            });
        });
    }
];