'use strict';
        
var settingsController = [
    "$scope",
    "$timeout",
    "$location",
    "$route",
    "$translate",
    "GeneanetDevice",
    "ConnexionService",
    "ConfigurationService",
    "GeneanetOverlay",
    function($scope, $timeout, $location, $route, $translate, GeneanetDevice, ConnexionService, ConfigurationService, GeneanetOverlay) {
        document.addEventListener('deviceready', GeneanetDevice.determineOrientationCurrentPage);

        $scope.login = false;
        $scope.logoutProgress = false;

        $scope.back = function() {
            window.history.back();
        }

        $scope.logout = function() {
            $scope.logoutProgress = true;
            $scope.$on("disconnect", function(event, data) {
                if (data.success) {
                    ConfigurationService.remove("login", function() {
                        $route.reload();
                    });
                } else {
                    $scope.$on("GeneanetOverlayClose", function() {
                        $route.reload();
                    });
                    GeneanetOverlay.openOverlay(
                        $translate.instant("alert.fail_connect_gnn"),
                        $translate.instant("alert.fail_connect_gnn_more")
                    );
                }
                $scope.logoutProgress = false;
            });
            ConnexionService.disconnect("disconnect");
        }

        $scope.connexion = function() {
            ConnexionService.setRedirect("/configuration/settings/");
            $timeout(function() {
                $scope.$apply(function() {
                    $location.path("/connexion/").replace();
                });
            }, 11);
        }

        $scope.$on("configurationLoaded", function() {
            if (ConfigurationService.exist("login")) {
                if(!$scope.$$phase) {
                    $scope.$apply(function() {
                        $scope.login = ConfigurationService.get("login");
                    });
                } else {
                    $scope.login = ConfigurationService.get("login");
                }
            }
        });
        ConfigurationService.loadConfig();
        
    }
]