"use strict";
        
var statisticsController = [
    "$scope",
    "GeneanetDevice",
    "GeneanetLocalStorage",
    "ConfigurationService",
    function($scope, GeneanetDevice, GeneanetLocalStorage, ConfigurationService) {
        document.addEventListener("deviceready", GeneanetDevice.determineOrientationCurrentPage);

        $scope.back = function() {
            window.history.back();
        };

        function toLocaleDateStringSupportsLocales() {
            try {
                new Date().toLocaleDateString("i");
            } catch (e) {
                return e.name === "RangeError";
            }
            return false;
        }

        $scope.picturesPublished = 0;
        $scope.projectsPublished = 0;

        $scope.$on("configurationLoaded", function() {
            var picturesPublished = parseInt(ConfigurationService.get("picturesPublished"));
            var projectsPublished = GeneanetLocalStorage.getItemWithDefaultValue("projectsPublished", [], "configuration").length;

            var dateStartCount = ConfigurationService.get("dateStartCount");
            dateStartCount = new Date(dateStartCount);
            
            if (toLocaleDateStringSupportsLocales()) {
                dateStartCount = dateStartCount.toLocaleDateString(navigator.language, {weekday: "long", year: "numeric", month: "long", day: "numeric"});
            } else {
                if (navigator.language.toLowerCase() === "en-us") {
                    dateStartCount = (dateStartCount.getMonth()+1) + "/" + dateStartCount.getDate() + "/" + dateStartCount.getFullYear();
                } else {
                    dateStartCount = dateStartCount.getDate() + "/" + (dateStartCount.getMonth()+1) + "/" + dateStartCount.getFullYear();
                }
            }

            if($scope.$$phase) {
                $scope.picturesPublished = picturesPublished;
                $scope.projectsPublished = projectsPublished;
                $scope.dateStartCount = dateStartCount;
            } else {
                $scope.$apply(function() {
                    $scope.picturesPublished = picturesPublished;
                    $scope.projectsPublished = projectsPublished;
                    $scope.dateStartCount = dateStartCount;
                });
            }
        });

        ConfigurationService.loadConfig();
    }
];