'use strict';

/**
 *  Service permettant de gérer la configuration de l'application.
 */
var configurationService = [
    "$rootScope",
    "GenerateSqlService",
    "GeneanetDatabase",
    function($rootScope, GenerateSqlService, GeneanetDatabase) {
        var configurations = null;
        var loaded = false;

        this.loadConfig = function(forceUpdate) {
            if (!loaded || forceUpdate) {
                var requestAllConfiguration = GenerateSqlService.getAllConfigurations();
                GeneanetDatabase.executeRequest(requestAllConfiguration, function(tx, results) {
                    configurations = {};
                    for (var i = 0; i < results.rows.length; i++) {
                        configurations[results.rows.item(i).key] = results.rows.item(i).value;
                    };
                    loaded = true;
                    $rootScope.$broadcast("configurationLoaded", {});
                });
            } else {
                $rootScope.$broadcast("configurationLoaded", {});
            }
        }
        

        this.get = function(key) {
            if (configurations == null) {
                return undefined;
            }

            return configurations[key];
        }

        this.exist = function(key) {
            if (configurations == null || !(key in configurations)) {
                return false;
            }

            return true;
        }

        this.add = function(key, value, callback) {
            if (configurations == null) {
                configurations = {};
            }

            var requestCheck = GenerateSqlService.getConfigurationsByKey(key);
            GeneanetDatabase.executeRequest(requestCheck, function(tx, results) {
                if (results.rows.length == 0) {
                    configurations[key] = value;
                    var requestInsert = GenerateSqlService.insertionConfiguration(key, value);
                    GeneanetDatabase.executeRequest(requestInsert, callback);
                }
            });
        }

        this.edit = function(key, value, callback) {
            configurations[key] = value;
            var requestUpdate = GenerateSqlService.updateConfiguration(key, value);
            GeneanetDatabase.executeRequest(requestUpdate, callback);
        }

        this.remove = function(key, callback) {
            delete(configurations[key]);
            var requestDelete = GenerateSqlService.deleteConfiguration(key);
            GeneanetDatabase.executeRequest(requestDelete, callback);
        }
    }
]