'use strict';

/**
 *  Service permettant de gérer la configuration de l'application.
 */
var connexionService = [
    "$rootScope",
    "$location",
    "$timeout",
    "urlsWebservice",
    function($rootScope, $location, $timeout, urlsWebservice) {
        var urlConnexion = urlsWebservice.connexionUrl;

        var redirect = null;

        this.getRedirect = function() {
            return redirect;
        }

        this.setRedirect = function(newRedirect) {
            redirect = newRedirect;
        }

        this.redirect = function() {
            if (!redirect) {
                redirect = "/";
            }

            $rootScope.$apply(function() {
                $timeout(function() {
                    $rootScope.$apply(function() {
                        $location.path(redirect).replace();
                    });
                }, 11);
            });
        }

        /**
         * Verifie que l'utilisateur est connecté.
         * 
         * @param  {string}  nameEvent Nom de l'évent sur lequel broadcast l'info.
         */
        this.isConnected = function(nameEvent) {
            execConnexion(nameEvent);
        }

        /**
         * Permet de connecter un utilisateur
         * 
         * @param  {string} login     Login GNN
         * @param  {string} password  Mot de passe GNN
         * @param  {string} nameEvent Nom de l'event sur lequel broadcast l'info.
         */
        this.connect = function(login, password, nameEvent) {
            execConnexion(nameEvent, {login: login, password: password});
        }

        var execConnexion = function(nameEvent, params) {
            if (!params) {
                params = {};
            }

            $.post(urlConnexion, params)
                .success(function(data) {
                    if (data == 1) {
                        $rootScope.$broadcast(nameEvent, {success: true});
                    } else {
                        $rootScope.$broadcast(nameEvent, {success: false});
                    }
                })
                .error(function(data) {
                    $rootScope.$broadcast(nameEvent, {success: false});
                })
            ;
        }

        this.disconnect = function(nameEvent) {
            execConnexion(nameEvent, {nologin: 1})
        }
    }
]