'use strict';

angular.module('GeneanetService').directive('gnnInfiniteScroll', [function () {
    return {
        restrict: 'A',
        scope: {
            functCalled: "&gnnInfiniteScroll",
            childElement: "=?gnnInfiniteScrollChild",
            stop: "=?gnnInfiniteScrollStop",
            distance: "&?gnnInfiniteScrollDistance"
        },
        link: function($scope, $element, $attr) {
            if ($scope.childElement == undefined) {
                $scope.childElement = $element.children().first();
            }
            if ($scope.stop == undefined) {
                $scope.stop = false;
            }
            if ($scope.distance == undefined) {
                $scope.distance = 0;
            }
            
            $element.scroll(function(){
                if (!$scope.stop) {
                    var heightContainer = $element.height();
                    var heightChild = $scope.childElement.height();
                    var topChild = Math.abs($scope.childElement.position().top);

                    var distance = $scope.distance();
                    if (typeof distance == "function") {
                        distance = distance();
                    }

                    if ((heightChild - (heightContainer + topChild)) <= distance) {
                        $scope.functCalled()();
                    }
                }
            });
        }
    };
}])