'use strict';

/**
 * Provider GeneanetApp
 * Contient les méthodes utiles pour récupérer:
 *     ** le nom de l'application **
 *     ** le dossier d'enregistrement des images **
 */
angular.module('GeneanetService').provider('GeneanetApp',[
    function (){
        /*Nom de l'application*/
        var name = "geneanet";

        /**
         * Permet de déterminer le nom de l'application
         * Il est aussi possible de lui ajouter un en argument
         */
        this.determineName = function(proposedName) {
            if (proposedName.trim().length > 0) {
                proposedName = proposedName.replace(" ", "_");
                name = proposedName;
            }
        };

        /**
         * Instanciation de GeneanetApp
         */
        this.$get = [function(){
            var GeneanetApp = new GeneanetAppPrototype();

            GeneanetApp.setName(name);

            return GeneanetApp;
        }];
    }
]);

/**
 * Contient toutes les méthodes utiles pour manipuler son application.
 */
var GeneanetAppPrototype = function () {
    var name;

    /*** Méthode SET ***/

    this.setName = function(newName) {
        name = newName;
    }

    /*** Méthode GET ***/

    this.getName = function () {
        return name;
    }
};