'use strict';

/**
 * Service GeneanetImage 
 * Contient les méthodes utiles pour 
 *     **  Copier une photo    **
 *     **  Supprimer une photo **  
 *     **  Nommer une photo    **
 */
angular.module('GeneanetService').service('GeneanetImage',[
    function(GeneanetFile, GeneanetDate) {
        this.resize = function(element, newWidth, newHeight, returnBase64) {
            var ratio;
            if (this.isLandscape(element)) {
                ratio = newHeight / element.naturalHeight;
                newWidth = Math.ceil(element.naturalWidth * ratio);
            } else {
                ratio = newWidth / element.naturalWidth;
                newHeight = Math.ceil(element.naturalHeight * ratio);
            }

            var canvas = document.createElement("canvas");
            canvas.width = newWidth;
            canvas.height = newHeight;

            var ctx = canvas.getContext("2d");
            ctx.drawImage(element, 0, 0, newWidth, newHeight);

            if (returnBase64 != undefined) {
                return canvas.toDataURL(returnBase64);
            } else {
                return canvas;
            }
        }

        this.isLandscape = function(element) {
            if (element.naturalWidth > element.naturalHeight) {
                return true;
            }
        }

        this.isPortrait = function(element) {
            if (element.naturalWidth < element.naturalHeight) {
                return true;
            }
        }
    }
]);